package com.FranckBarbier.Java._Pedagogical_RSA;

import java.math.BigInteger;

public class Pedagogical_RSA_using_BigInteger {

    private BigInteger _message;
    private BigInteger _p, _q, _e, _n, _phi_of_n, _d;

    public Pedagogical_RSA_using_BigInteger(String message) {
        if (message == null) {
            throw new RuntimeException("Pedagogical_RSA_using_BigInteger: No way...");
        }
        _message = new BigInteger(message.getBytes());
        _p = new BigInteger(32, 4, new java.util.Random()); // Probality to have a prime is 1 - (.5 * .5 * .5 * .5) = 93.75%
        _q = new BigInteger(32, 4, new java.util.Random());
        _e = new BigInteger(8, 4, new java.util.Random());
        _n = _p.multiply(_q);
        _phi_of_n = _p.subtract(BigInteger.ONE).multiply(_q.subtract(BigInteger.ONE));
        _d = _e.modInverse(_phi_of_n);
    }

    public void encrypt() {
        _message = _message.modPow(_e, _n);
    }

    public void decrypt() {
        _message = _message.modPow(_d, _n);
    }

    public String message() {
        return new String(_message.toByteArray());
    }

    public static void main(String[] args) {
        Pedagogical_RSA_using_BigInteger p_rsa = new Pedagogical_RSA_using_BigInteger("Franck"); // Max. 8 characters
        System.out.println("message: " + p_rsa.message());
        p_rsa.encrypt();
        System.out.println("message: " + p_rsa.message());
        p_rsa.decrypt();
        System.out.println("message: " + p_rsa.message());
    }
}
